import 'dart:convert';

import 'file:///D:/Repo/ekmekk/butler/butler_flutter/lib/src/Butler.dart';
import 'package:dio/dio.dart';
import 'package:http/http.dart' as http;


class ButlerWorker
{
  var _path="";
  var _paramaters = Map<String, dynamic>();
  var type="";

  ButlerWorker(this.type);

  ButlerWorker Path(path)
  {
    _path = path;
    return this;
  }
  ButlerWorker Paramaters(paramaters)
  {

    _paramaters = paramaters;
    return this;
  }
  void Then(callback)
  {
    if(type == "post")
      {
        _Post(callback);
      }
    else  if(type == "get")
    {
      _Get(callback);
    }
    else if(type == "put")
    {
      _Put(callback);
    }
    else  if(type == "delete")
    {
      _Delete(callback);
    }
    else  if(type == "form")
    {
      _Form(callback);
    }

  }

  Future<void> _Post(callback)
  async {


    final JsonDecoder _decoder = new JsonDecoder();

    var response = await http.post(Butler.URL+"/"+_path, body: _paramaters);


    var decoder = _decoder.convert(response.body);

    callback(decoder);

  }
  Future<void> _Get(callback)
  async {
    final JsonDecoder _decoder = new JsonDecoder();

    var response = await http.get(Butler.URL+"/"+_path);
    var decoder = _decoder.convert(response.body);
    callback(decoder);
  }
  Future<void> _Delete(callback)
  async {
    final JsonDecoder _decoder = new JsonDecoder();

    var response = await http.delete(Butler.URL+"/"+_path);
    var decoder = _decoder.convert(response.body);
    callback(decoder);
  }
  Future<void> _Put(callback)
  async {
    final JsonDecoder _decoder = new JsonDecoder();

    var response = await http.put(Butler.URL+"/"+_path,body: _paramaters);
    var decoder = _decoder.convert(response.body);
    callback(decoder);
  }

  void _Form(callback)
  {
    FormData data = FormData.fromMap(_paramaters);

    Dio dio = new Dio();

    dio.post(Butler.URL+"/"+_path, data: data)
        .then(callback)
        .catchError((error) => print(error));
  }
}